#!/bin/dash
# (C) James Budiono, 2013
# License: GPL Version 3 or later.
#
# run as per-user X daemon (e.g from /etc/xdg/Startup)
#
### configuration
FLAG=/tmp/redraw-icons.$$
#exec 2> /dev/null

### main
# kill process run by the same username
for p in ${FLAG%.*}.*; do
	! [ -f $p ] && continue
	if [ $(stat -c %u $p) -eq $(id -u) ]; then
		pid=${p##*.}
		
		# check if process is still up
		if kill -0 $pid 2>/dev/null; then
			disp="$(tr '\0' '\n' < /proc/$pid/environ | sed '/DISPLAY=/!d;s/DISPLAY=//')"
			[ $disp = $DISPLAY ] && rm -f $p # same display, kill it
		else
			rm -f $p # process already dead, remove its ghosts
		fi
	fi
done

trap 'rm -f $FLAG; exit;' 0 INT TERM HUP
touch $FLAG
inotifyd - $FLAG:e | while read p; do
	fatdog-drive-icon-redraw-icons.sh
done
